## ocsigenserver 6.0.0

=== Makefile ===
include Makefile.config
include Makefile.options

### Building

.PHONY: default all doc
default all: build

.PHONY: build
build:
	${MAKE} -C src
doc:
	$(MAKE) -C doc

### Testing : local execution and toplevel ###

.PHONY: run.local run.opt.local top

run.local: build install.files
	CAML_LD_LIBRARY_PATH=${BLD}/server:$(CAML_LD_LIBRARY_PATH) ${BLD}/ocsigenserver.bc -c local/etc/ocsigenserver.conf

run.opt.local: build install.files
	CAML_LD_LIBRARY_PATH=${BLD}/server:$(CAML_LD_LIBRARY_PATH) ${BLD}/ocsigenserver.exe -c local/etc/ocsigenserver.conf

top:
	cd src/server && ${MAKE} top

### Cleaning ###

clean: clean.local
	${MAKE} -C src clean

clean.local:
	-rm -f ocsigenserver-*.tar.gz

distclean: clean.local
	${MAKE} -C src distclean
	-make -C doc clean
	-rm Makefile.config
	-rm -f *~ \#* .\#*

### Installation ####

.PHONY: purge.files install.files

# BB If install is not run by root but OCSIGENUSER, OCSIGENGROUP is somebody
# BB different, make files universally accessible, we cannot chown.
INSTALL_CAN_PUT_PERMISSIONS=yes
INSTALL_USER_GROUP=-o $(OCSIGENUSER) -g "$(OCSIGENGROUP)"
INSTALL_MOD_660=660
INSTALL_MOD_644=644
INSTALL_MOD_755=755
INSTALL_MOD_770=770
INSTALL_MOD_750=750
USERNAME=$(shell whoami)
ifneq ($(shell id -u), 0)
  ifneq ($(OCSIGENUSER), $(USERNAME))
    INSTALL_CAN_PUT_PERMISSIONS=no
  endif
  ifneq ($(shell groups ${USERNAME}|grep -q ${OCSIGENGROUP}; echo $$?), 0)
    INSTALL_CAN_PUT_PERMISSIONS=no
  endif
endif
ifeq ($(INSTALL_CAN_PUT_PERMISSIONS), no)
    INSTALL_USER_GROUP=
    INSTALL_MOD_660=666
    INSTALL_MOD_644=666
    INSTALL_MOD_755=777
    INSTALL_MOD_770=777
    INSTALL_MOD_750=777
endif

install.files:
	@echo
	@echo "## Run \"make doc\" and \"make install.doc\" to build and install the ocamldoc."
	@echo INSTALL_CAN_PUT_PERMISSIONS: ${INSTALL_CAN_PUT_PERMISSIONS}
	 ## Configuration files
	$(INSTALL) -m ${INSTALL_MOD_755} -d $(TEMPROOT)$(CONFIGDIR)/conf.d
	${INSTALL} -m ${INSTALL_MOD_644} ocsigenserver.conf.sample $(TEMPROOT)$(CONFIGDIR)/
	[ -f $(TEMPROOT)$(CONFIGDIR)/ocsigenserver.conf ] || \
	  { $(INSTALL) -m ${INSTALL_MOD_644} ocsigenserver.conf.sample \
		$(TEMPROOT)$(CONFIGDIR)/ocsigenserver.conf;  }
	-mv $(TEMPROOT)$(CONFIGDIR)/mime.types $(TEMPROOT)$(CONFIGDIR)/mime.types.old
	 ## Log directory
	$(INSTALL) -m ${INSTALL_MOD_644} src/files/mime.types $(TEMPROOT)$(CONFIGDIR)
	$(INSTALL) -d -m ${INSTALL_MOD_755} ${INSTALL_USER_GROUP} $(TEMPROOT)$(LOGDIR)
	 ## Static files
	$(INSTALL) -d -m ${INSTALL_MOD_755} ${INSTALL_USER_GROUP} $(TEMPROOT)$(STATICPAGESDIR)
	$(INSTALL) -d -m ${INSTALL_MOD_750} ${INSTALL_USER_GROUP} $(TEMPROOT)$(DATADIR)
	$(INSTALL) -m ${INSTALL_MOD_644} ${INSTALL_USER_GROUP} \
	  local/var/www/*.html $(TEMPROOT)$(STATICPAGESDIR)
	$(INSTALL) -d -m ${INSTALL_MOD_755} ${INSTALL_USER_GROUP} \
	  $(TEMPROOT)$(STATICPAGESDIR)/ocsigenstuff
	$(INSTALL) -m ${INSTALL_MOD_644} ${INSTALL_USER_GROUP} \
	  local/var/www/ocsigenstuff/*.png local/var/www/ocsigenstuff/*.css \
	  $(TEMPROOT)$(STATICPAGESDIR)/ocsigenstuff
	$(INSTALL) -d -m ${INSTALL_MOD_755} $(TEMPROOT)$(MANDIR)
	$(INSTALL) -m ${INSTALL_MOD_644} src/files/ocsigenserver.1 $(TEMPROOT)$(MANDIR)

uninstall:
	-make -C doc uninstall
	-rm -f $(TEMPROOT)$(CONFIGDIR)/ocsigenserver.conf.sample
	-rm -f $(TEMPROOT)$(MANDIR)/ocsigenserver.1
	-rm -f $(TEMPROOT)$(COMMANDPIPE)
	-rmdir --ignore-fail-on-non-empty $(TEMPROOT)$(CONFIGDIR)/conf.d
	-rmdir --ignore-fail-on-non-empty $(TEMPROOT)$(CONFIGDIR)
	-rmdir --ignore-fail-on-non-empty $(TEMPROOT)$(LOGDIR)
	-rmdir --ignore-fail-on-non-empty $(TEMPROOT)$(DATADIR)
	-rmdir --ignore-fail-on-non-empty $(TEMPROOT)$(MANDIR)

purge: purge.files

purge.files:
	-rm -f $(TEMPROOT)$(CONFIGDIR)/mime.types $(TEMPROOT)$(CONFIGDIR)/mime.types.old
	-rm -f $(TEMPROOT)$(CONFIGDIR)/ocsigenserver.conf
	-rm -f $(patsubst local/var/www/ocsigenstuff/%, \
			  $(TEMPROOT)$(STATICPAGESDIR)/ocsigenstuff/%, \
			  $(wildcard local/var/www/ocsigenstuff/*))
	-rmdir --ignore-fail-on-non-empty $(TEMPROOT)$(STATICPAGESDIR)/ocsigenstuff
	-rm -f $(patsubst local/var/www/%, \
			  $(TEMPROOT)$(STATICPAGESDIR)/%, \
			  $(wildcard local/var/www/*.html))
	-rmdir --ignore-fail-on-non-empty $(TEMPROOT)$(STATICPAGESDIR)

install.doc:
	${MAKE} -C doc install

### Install logrotate configuration files ###

.PHONY: logrotate

logrotate:
	 $(INSTALL) -m 755 -d $(TEMPROOT)/etc/logrotate.d
	 cat src/files/logrotate.in \
	     | sed s%LOGDIR%$(LOGDIR)%g \
	     | sed s%USER%$(OCSIGENUSER)%g \
	     | sed s%GROUP%"$(OCSIGENGROUP)"%g \
	     | sed s%_COMMANDPIPE_%$(COMMANDPIPE)%g \
	     > $(TEMPROOT)/etc/logrotate.d/ocsigenserver

=== doc/Makefile ===
include ../Makefile.config
include ../Makefile.options

OCAMLDOC := ${OCAMLFIND} ocamldoc
ODOC_WIKI := odoc_wiki.cma

DOC := baselib/ocsigen_cache.mli          \
       baselib/ocsigen_lib_base.mli       \
       baselib/ocsigen_lib.mli            \
       baselib/ocsigen_config_static.mli  \
       baselib/ocsigen_stream.mli         \
       baselib/ocsigen_loader.mli         \
       baselib/polytables/polytables.mli  \
       \
       http/ocsigen_charset_mime.mli      \
       http/ocsigen_cookie_map.mli        \
       http/ocsigen_header.mli            \
       \
       server/ocsigen_config.mli          \
       server/ocsigen_command.mli          \
       server/ocsigen_request.mli         \
       server/ocsigen_response.mli        \
       server/ocsigen_messages.mli        \
       server/ocsigen_multipart.mli       \
       server/ocsigen_extensions.mli      \
       server/ocsigen_parseconfig.mli     \
       server/ocsigen_local_files.mli     \
       server/ocsigen_server.mli

PLUGINS_DOC := extensions/accesscontrol.mli \
           extensions/authbasic.mli	\
	       extensions/outputfilter.mli \
	       extensions/extendconfiguration.mli \
	       extensions/redirectmod.mli \
	       extensions/rewritemod.mli \
	       extensions/userconf.mli \
	       extensions/revproxy.mli \
	       extensions/staticmod.mli	\
	       extensions/deflatemod.mli \
	       extensions/cors.mli

all: doc wikidoc

doc: api-html/index.html
api-html/index.html: indexdoc $(addprefix ../src/,$(DOC) $(PLUGINS_DOC))
	mkdir -p api-html
	$(OCAMLDOC) ${LIBS} -d api-html -intro indexdoc -html $(addprefix ../src/,$(DOC) $(PLUGINS_DOC))

wikidoc: api-wiki/index.wiki
api-wiki/index.wiki: indexdoc $(addprefix ../src/,$(DOC) $(PLUGINS_DOC))
	mkdir -p api-wiki
	$(OCAMLDOC) ${LIBS} -d api-wiki -intro indexdoc -colorize-code \
	   -i $(shell ocamlfind query wikidoc) -g ${ODOC_WIKI} \
	   $(addprefix ../src/,$(DOC) $(PLUGINS_DOC))

install:
	${INSTALL} -d -m 755 $(TEMPROOT)$(DOCDIR)
	$(INSTALL) -m 644 api-html/* $(TEMPROOT)$(DOCDIR)

uninstall:
	-rm -Rf $(TEMPROOT)$(DOCDIR)

clean:
	-rm -f api-html/* api-wiki/*
	-rm -f *~ \#* .\#*

=== src/Makefile ===
include ../Makefile.config

all: confs
	dune build @all

### CONF ####

confs: ../ocsigenserver.conf.sample ../local/etc/ocsigenserver.conf
	${MAKE} -C baselib confs

../ocsigenserver.conf.sample: files/ocsigenserver.conf.in ../Makefile.config Makefile
	cat $< \
	  | sed s%_LOGDIR_%$(LOGDIR)%g \
	  | sed s%_DATADIR_%$(DATADIR)%g \
	  | sed s%_COMMANDPIPE_%$(COMMANDPIPE)%g \
	  | sed s%_MIMEFILE_%$(CONFIGDIR)/mime.types%g \
	  | sed s%_METADIR_%$(LIBDIR)%g \
	  | sed s%_LIBDIR_%$(LIBDIR)%g \
	  | sed s%_EXTDIR_%$(LIBDIR)/ocsigenserver/extensions%g \
	  | sed s%_CONFIGDIR_%$(CONFIGDIR)%g \
	  | sed s%_STATICPAGESDIR_%$(STATICPAGESDIR)%g \
	  | sed s%_EXTPACKAGENAME_%ocsigenserver.ext%g \
	  > $@

../local/etc/ocsigenserver.conf: files/ocsigenserver.conf.in ../Makefile.config Makefile
	mkdir -p ../local/etc ../local/var/log ../local/var/run
	cat $< \
	  | sed s%80\</port\>%8080\</port\>%g \
	  | sed s%_LOGDIR_%$(SRC)/local/var/log%g \
	  | sed s%_DATADIR_%$(SRC)/local/var/lib%g \
	  | sed s%_COMMANDPIPE_%$(SRC)/local/var/run/ocsigenserver_command%g \
	  | sed s%_MIMEFILE_%$(SRC)/src/files/mime.types%g \
	  | sed s%_METADIR_%${LIBDIR}\"/\>\<findlib\ path=\"$(SRC)/src/files/\"/\>\<findlib\ path=\"$(SRC)/src/extensions/files/%g \
	  | sed s%_CONFIGDIR_%$(SRC)/local/etc/ocsigenserver%g \
	  | sed s%_STATICPAGESDIR_%$(SRC)/local/var/www%g \
	  | sed s%_EXTPACKAGENAME_%ocsigenserver.ext%g \
	  | sed s%\<\!--\ \<commandpipe%\<commandpipe%g \
	  | sed s%\</commandpipe\>\ --\>%\</commandpipe\>%g \
	  | sed s%\<\!--\ \<mimefile%\<mimefile%g \
	  | sed s%\</mimefile\>\ --\>%\</mimefile\>%g \
	  > $@

###

clean: clean.local
	${MAKE} -C baselib clean
	dune clean

clean.local:
	-rm -f ../ocsigenserver.conf.sample
	-rm -f ../ocsigenserver.conf.opt.sample
	-rm -f ../ocsigenserver.conf.local
	-rm -f ../ocsigenserver.conf.opt.local

distclean: clean.local
	${MAKE} -C baselib distclean
	${MAKE} -C http distclean
	${MAKE} -C server distclean
	${MAKE} -C extensions distclean
	-rm -f *~ \#* .\#*
	-cd files; rm -f *~ \#* .\#*
	-rm -fr ../local/var/log/*.log
	-rm -fr ../local/var/lib/ocsidb
	-rm -fr ../local/etc/ocsigenserver.conf
	-rm -fr ../local/etc/ocsigenserver.conf.opt

=== src/baselib/Makefile ===
include ../../Makefile.config

.PHONY: default
default: build

.PHONY: build
build: confs
	dune build

.PHONY: confs
confs: ocsigen_config_static.ml

## Ocsigen_config ##

VERSION := $(shell head -n 1 ../../VERSION)

ocsigen_config_static.ml: ocsigen_config_static.ml.in ../../Makefile.config ../../Makefile.options ../../VERSION
	cat ocsigen_config_static.ml.in \
	| sed s%_VERSION_%${VERSION}% \
	| sed s%_WARNING_%"Warning: this file has been generated from ocsigen_config_static.ml.in - DO NOT MODIFY MANUALLY!"% \
	| sed s%_LOGDIR_%$(LOGDIR)% \
	| sed s%_DATADIR_%$(DATADIR)%g \
	| sed s%_BINDIR_%$(BINDIR)%g \
	| sed s%_EXTDIR_%$(LIBDIR)/ocsigenserver/extensions%g \
	| sed s%_STATICPAGESDIR_%$(STATICPAGESDIR)% \
	| sed s%_UP_%$(UPLOADDIR)%g \
	| sed s%_COMMANDPIPE_%$(COMMANDPIPE)%g \
	| sed s%_CONFIGDIR_%$(CONFIGDIR)% \
	| sed s%_ISNATIVE_%$(NATIVECODE_RUNTIME_DETECT)%g \
	| sed "s%_DEPS_%$(INITPACKAGE)%g" \
	> ocsigen_config_static.ml

## Clean up

clean:
	-rm -f ocsigen_config_static.ml

distclean: clean
	-rm -f *~ \#* .\#*

=== src/server/Makefile ===
include ../../Makefile.options
include ../../Makefile.config

.PHONY: default
default: build

.PHONY: build
build:
	dune build

## Toplevel

SERVERLIBS := ${BLD}/baselib/ocsigen_lib_base.cma      \
	      ${BLD}/baselib/baselib.cma               \
	      ${BLD}/baselib/polytables/polytables.cma \
	      ${BLD}/http/http.cma                     \
	      ${BLD}/http/ocsigen_cookie_map.cma       \
	      ${BLD}/server/ocsigenserver.cma

top: servertop
	OCAMLPATH=${SRC}/src/files/:${OCAMLPATH} ${RLWRAP} ./servertop

servertop: build
	OCAMLPATH=${SRC}/src/files/:${OCAMLPATH} ${OCAMLFIND} ocamlmktop \
	   -o $@ -linkall -linkpkg ${THREAD} ${LIBS} ${SERVERLIBS}

## Clean up

clean:
	dune clean

distclean: clean
	-rm -f *~ \#* .\#*
	-rm -f servertop

=== debian/changelog ===
ocsigenserver (6.0.0-1build11) resolute; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 22 Oct 2025 22:51:00 +0200

ocsigenserver (6.0.0-1build10) questing; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 01 Sep 2025 08:20:48 +0200

ocsigenserver (6.0.0-1build9) questing; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 19 Jun 2025 18:38:07 +0200

ocsigenserver (6.0.0-1build8) questing; urgency=medium

  * Rebuild against latest ocaml libraries

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sat, 10 May 2025 07:35:31 -0400

ocsigenserver (6.0.0-1build7) plucky; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 13 Mar 2025 18:47:59 +0100

ocsigenserver (6.0.0-1build6) plucky; urgency=medium

  * No change rebuild against new OCAML ABIs

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 03 Mar 2025 10:03:07 +0100

ocsigenserver (6.0.0-1build5) plucky; urgency=medium

  * No-change rebuild against new OCAML ABI.

 -- Rik Mills <rikmills@kde.org>  Sun, 16 Feb 2025 09:06:11 +0000

ocsigenserver (6.0.0-1build4) plucky; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 12 Feb 2025 22:15:11 +0100

ocsigenserver (6.0.0-1build3) plucky; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 31 Jan 2025 09:30:44 +0100

ocsigenserver (6.0.0-1build2) plucky; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 23 Jan 2025 09:44:07 +0100

ocsigenserver (6.0.0-1build1) plucky; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 02 Jan 2025 18:06:28 +0100

ocsigenserver (6.0.0-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.7.0

 -- Stéphane Glondu <glondu@debian.org>  Tue, 24 Sep 2024 12:22:47 +0200

=== debian/control ===
Source: ocsigenserver
Section: ocaml
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders:
 Stéphane Glondu <glondu@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 ocaml,
 ocaml-dune,
 ocaml-findlib,
 liblwt-ocaml-dev (>= 3.0.0),
 liblwt-ssl-ocaml-dev,
 liblwt-log-ocaml-dev,
 libzip-ocaml-dev,
 libre-ocaml-dev (>= 1.11.0),
 libsqlite3-ocaml-dev,
 libcryptokit-ocaml-dev,
 libfindlib-ocaml-dev,
 libipaddr-ocaml-dev,
 libxml-light-ocaml-dev,
 libcohttp-lwt-unix-ocaml-dev (>= 5.1.0),
 dh-ocaml (>= 1.2)
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://ocsigen.org/ocsigenserver/
Vcs-Browser: https://salsa.debian.org/ocaml-team/ocsigenserver
Vcs-Git: https://salsa.debian.org/ocaml-team/ocsigenserver.git

Package: ocsigenserver
Section: httpd
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Suggests: ocsigenserver-doc
Description: web server of the Ocsigen project
 The Ocsigen project is aimed at proposing clean and safe tools for
 developing and running client/server Web 2.0 applications.
 .
 Ocsigen Server is a full featured Web server. It implements most
 features of the HTTP protocol, and has a very powerful extension
 mechanism that make very easy to plug your own OCaml modules for
 generating pages. Many extensions are available, like a reverse
 proxy, content compression, access control, authentication, etc.

Package: libocsigenserver-ocaml
Architecture: any
Depends:
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Breaks: libocsigenserver-ocaml-dev (<< 5)
Replaces: libocsigenserver-ocaml-dev (<< 5)
Provides: ${ocaml:Provides}
Suggests: ocaml-findlib
Description: web server of the Ocsigen project (runtime libraries)
 The Ocsigen project is aimed at proposing clean and safe tools for
 developing and running client/server Web 2.0 applications.
 .
 Ocsigen Server is a full featured Web server. It implements most
 features of the HTTP protocol, and has a very powerful extension
 mechanism that make very easy to plug your own OCaml modules for
 generating pages. Many extensions are available, like a reverse
 proxy, content compression, access control, authentication, etc.
 .
 This package contains runtime libraries.

Package: libocsigenserver-ocaml-dev
Architecture: any
Depends:
 ocaml-findlib,
 ${ocaml:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides: ${ocaml:Provides}
Recommends: ocsigenserver-doc
Description: web server of the Ocsigen project (dev libraries)
 The Ocsigen project is aimed at proposing clean and safe tools for
 developing and running client/server Web 2.0 applications.
 .
 Ocsigen Server is a full featured Web server. It implements most
 features of the HTTP protocol, and has a very powerful extension
 mechanism that make very easy to plug your own OCaml modules for
 generating pages. Many extensions are available, like a reverse
 proxy, content compression, access control, authentication, etc.
 .
 This package contains development libraries.

Package: ocsigenserver-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Enhances: ocsigenserver, libocsigenserver-ocaml-dev
Multi-Arch: foreign
Description: web server of the Ocsigen project (documentation)
 The Ocsigen project is aimed at proposing clean and safe tools for
 developing and running client/server Web 2.0 applications.
 .
 Ocsigen Server is a full featured Web server. It implements most
 features of the HTTP protocol, and has a very powerful extension
 mechanism that make very easy to plug your own OCaml modules for
 generating pages. Many extensions are available, like a reverse
 proxy, content compression, access control, authentication, etc.
 .
 This package contains documentation: the manual (in wikicreole
 format) and the API reference generated by ocamldoc (in HTML format).

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/ocaml/ocamlvars.mk

DESTDIR := $(CURDIR)/debian/tmp

%:
	dh $@ --with ocaml --buildsystem ocaml_dune

execute_after_dh_auto_clean:
	rm -rf doc/api-html local/etc local/var/log local/var/run

override_dh_auto_configure:
	mkdir -p local/etc
	sh configure \
	    --temproot $(DESTDIR) \
	    --prefix /usr \
	    --bindir /usr/bin \
	    --libdir $(OCAML_STDLIB_DIR) \
	    --mandir /usr/share/man/man1 \
	    --docdir /usr/share/doc/ocsigenserver/api-html \
	    --staticpagesdir /usr/share/ocsigenserver \
	    --ocsigen-user ocsigen \
	    --ocsigen-group ocsigen
	$(MAKE) -C src confs

execute_after_dh_auto_build-indep:
	$(MAKE) doc

execute_after_dh_auto_install-indep:
	$(MAKE) install.doc

=== debian/watch ===
version=4
https://github.com/ocsigen/ocsigenserver/tags .*/(.*)\.tar\.gz
